<script setup>
import { ref, nextTick, computed, watch } from "vue";
import { useStore } from "vuex";
import Comment from "@components/Level/Comment.vue";
import PopUp from "@components/Template/PopUp.vue";

const store = useStore();
const props = defineProps({
  stateId: { type: String, required: true },
  state: { type: Object, required: true },
  isLive: { type: Boolean, required: true },
  sessionSelected: { type: Boolean, required: true },
  isSelected: { type: Boolean, required: true },
  isBusy: { type: Object, required: false, default: undefined },
});

const isNameEdit = ref(false);
const nameInput = ref(undefined);
const commentRef = ref();
const showComments = ref(false);
const copiedAction = computed(() => store.state.level.copiedAction);
const editingStateName = computed(() => store.state.level.editingStateName);
const addingStateComment = computed(() => store.state.level.addingStateComment);

watch(editingStateName, (newVal) => {
  if (newVal === props.stateId) {
    unlockNameEdit(props.state.name);
    store.commit("level/SET_LEVEL_DATA", { key: "editingStateName", value: null });
  }
});

watch(addingStateComment, (newVal) => {
  if (newVal === props.stateId) {
    showComments.value = true;
    nextTick(() => {
      commentRef.value.triggerAddComment();
    });
    store.commit("level/SET_LEVEL_DATA", { key: "addingStateComment", value: null });
  }
});

function unlockNameEdit(name) {
  if (name == "START" || name == "QUIT" || props.isLive || !props.isSelected) return;
  isNameEdit.value = true;
  nextTick(() => {
    nameInput.value.focus;
    nameInput.value.setActive; // make the textbox/textarea the one that is going to receive mouse and keyboard input
    nameInput.value.select(); // some browsers require this line of code for it to work right
  });
}

function updateName(e) {
  isNameEdit.value = false;
  if (e.target.value === props.state.name) return;
  store
    .dispatch("level/updateStateName", { stateId: props.stateId, name: e.target.value })
    .catch(() => (e.target.value = props.state.name));
}

function triggerState() {
  store.dispatch("live/triggerState", props.stateId);
}

function deleteState() {
  store.dispatch("level/deleteState", props.stateId);
}

function duplicateState() {
  store.dispatch("level/duplicateState", props.stateId);
}

function pasteAction() {
  store.dispatch("level/pasteAction", props.stateId);
}

function updateComment(index, comment) {
  store.dispatch("level/updateComment", {
    stateId: props.stateId,
    index,
    comment,
  });
  showComments.value = false;
}

function deleteComment(index) {
  store.dispatch("level/deleteComment", { stateId: props.stateId, index });
  showComments.value = false;
}
</script>
<template>
  <div class="p-1">
    <div style="position: absolute; top: -20px; left: -20px">
      <div v-if="isBusy" class="user-dot" :title="isBusy.user">
        {{ isBusy.user.substring(0, 2) }}
      </div>
    </div>
    <div class="level is-unselectable mb-0" :title="`${state.name} [${state?.path || ''}]`">
      <div class="level-left">
        <div
          v-if="isLive && sessionSelected"
          class="level-item pt-1 pl-1"
          :title="`trigger ${state.name}`"
          @click="triggerState"
        >
          <span class="icon has-text-is-live">
            <Icon :interactive="true" :icon="'play-circle'" />
          </span>
        </div>
        <div v-else-if="isLive" class="level-item pt-1 pl-1" title="No session selected">
          <span class="icon has-text-pink-5">
            <Icon :interactive="false" :icon="'play-circle'" />
          </span>
        </div>
        <div class="level-item">
          <div class="field">
            <div class="control">
              <h5
                v-show="!isNameEdit"
                class="state-name"
                :class="{
                  'has-text-purple-1': state.name == 'START' || state.name == 'QUIT',
                }"
                @dblclick.stop="unlockNameEdit(state.name)"
              >
                {{ state.name }}
              </h5>
              <input
                v-show="isNameEdit"
                ref="nameInput"
                :value="state.name"
                class="input is-full-height has-text-weight-semibold has-background-light"
                type="text"
                @mousedown.stop
                @mousemove.stop
                @mouseup.stop
                @mouseleave.stop
                @blur="updateName"
                @keyup.enter="updateName"
              />
            </div>
          </div>
        </div>
      </div>
      <div
        class="level-right"
        @mousedown="
          (e) => {
            if (isLive) e.stopPropagation();
          }
        "
      >
        <div class="level-item">
          <PopUp>
            <template #anchor="{ togglePopup }">
              <span
                class="icon"
                @click="
                  {
                    if (isSelected) togglePopup();
                  }
                "
              >
                <Icon :icon="'menu'" />
              </span>
            </template>
            <template #content="{ togglePopup }">
              <div v-if="copiedAction" class="dropdown-item is-interactive-2">
                <span
                  class="icon-text is-interactive is-flex-wrap-nowrap"
                  @click="
                    pasteAction();
                    togglePopup();
                  "
                >
                  <span class="icon">
                    <Icon :icon="'clipboard'" />
                  </span>
                  <span>
                    Paste Action
                    <br />
                    <i>{{ copiedAction.actionTitle }}</i>
                  </span>
                </span>
              </div>
              <hr v-if="copiedAction" class="dropdown-divider" />
              <div
                class="dropdown-item is-interactive-2"
                @click="
                  showComments = true;
                  commentRef.triggerAddComment();
                  togglePopup();
                "
              >
                <span class="icon-text is-interactive">
                  <span class="icon">
                    <Icon :icon="'message-square'" />
                  </span>
                  <span>Add Comment</span>
                </span>
              </div>
              <hr v-if="state.name != 'START' && state.name != 'QUIT' && !isLive" class="dropdown-divider" />
              <div
                v-if="state.name != 'START' && state.name != 'QUIT' && !isLive"
                class="dropdown-item is-interactive-2"
                @click="
                  unlockNameEdit(state.name);
                  togglePopup();
                "
              >
                <span class="icon-text is-interactive">
                  <span class="icon">
                    <Icon :icon="'edit-3'" />
                  </span>
                  <span>Edit State Name</span>
                </span>
              </div>
              <hr v-if="!isLive" class="dropdown-divider" />
              <div
                v-if="!isLive"
                class="dropdown-item is-interactive-2"
                @click="
                  duplicateState();
                  togglePopup();
                "
              >
                <span class="icon-text is-interactive">
                  <span class="icon">
                    <Icon :icon="'copy'" />
                  </span>
                  <span>Duplicate State</span>
                </span>
              </div>
              <hr v-if="state.name != 'START' && state.name != 'QUIT' && !isLive" class="dropdown-divider" />
              <div
                v-if="state.name != 'START' && state.name != 'QUIT' && !isLive"
                class="dropdown-item is-interactive-2"
              >
                <PopUp>
                  <template #anchor="{ togglePopup: toggleNestedPopup }">
                    <span class="icon-text is-interactive" @click.stop="toggleNestedPopup">
                      <span class="icon">
                        <Icon :icon="'trash-2'" />
                      </span>
                      <span>Delete State</span>
                    </span>
                  </template>
                  <template #content="{ togglePopup: toggleNestedPopup }">
                    <div class="dropdown-item p-1">
                      <div class="field is-grouped is-justify-content-space-between">
                        <p class="control">
                          <button class="button is-danger" @click="deleteState()">Delete</button>
                        </p>
                        <p class="control">
                          <button class="button" @click="toggleNestedPopup">Cancel</button>
                        </p>
                      </div>
                    </div>
                  </template>
                </PopUp>
              </div>
            </template>
          </PopUp>
        </div>
        <div class="level-item">
          <Comment
            v-show="state.comments?.length || showComments"
            ref="commentRef"
            :comments="state.comments || []"
            @update-comment="updateComment"
            @delete-comment="deleteComment"
            @cancel="showComments = false"
          />
        </div>
      </div>
    </div>
  </div>
</template>
